/*
 * Center: 98 
 * Subcenter: 232 
 * Parameter table version: 181 
 */

TBLE2 mpi_181_params[] = {
{18, "previous year NPP", "-", "prev_year_npp"},
{19, "average NPP", "-", "ave_npp"},
{20, "previous day maximum 10m windspeed", "m/s", "prev_day_max_wind10"},
{21, "relative humidity", "-", "rel_hum_air"},
{23, "maximum 10m windspeed", "m/s", "max_wind10"},
{31, "fractional plant cover", "-", "act_fpc"},
{32, "burned area fraction", "-", "burned_fpc"},
{33, "damaged area fraction", "-", "damaged_fpc"},
{34, "desert fraction", "-", "desert_fpc"},
{35, "bare soil fraction", "-", "bare_fpc"},
{38, "potential plant cover fraction", "-", "pot_fpc"},
{39, "bio exist", "-", "bio_exist"},
{40, "vegetated fraction calculated from green biomass", "mol(C) m-2(canopy)", "sum_green_bio_memory"},
{43, "CO2 emitted to the atmosphere by fire", "mol(C)/m^2(grid box)", "carbon_2_atmos"},
{130, "NPP that could not be not stored in vegetation carbon pools", "mol(CO2) m-2(canopy) s-1", "excess_NPP"},
{131, "root exudates", "mol(C) m-2(canopy) s-1", "root_exudates"},
{132, "Cflux_herbivory", "mol(C) m-2(canopy) s-1", "Cflux_herbivory"},
{133, "Cflux_herbivory_LG", "mol(C) m-2(canopy) s-1", "Cflux_herbivory_LG"},
{134, "Cflux_herbivory_2_atm", "mol(C) m-2(canopy) s-1", "Cflux_herbivory_2_atm"},
{135, "root exudates", "mol(C) m-2(grid box) s-1", "box_root_exudates"},
{136, "Cflux_herbivory", "mol(C) m-2(grid box) s-1", "box_Cflux_herbivory"},
{138, "jsbach carbon conservation test", "mol(CO2) m-2(grid box)", "jsbachCconserv"},
{157, "Flux correction for NPP", "mol(CO2) m-2(canopy) s-1", "NPP_flux_correction"},
{158, "Net Primary Production Rate (avg)", "mol(CO2) m-2(canopy) s-1", "NPP_Rate_acc"},
{159, "C-Pool for woody litter", "mol(C) m-2(grid box)", "boxC_litter_wood"},
{160, "C-Pool for Green Parts of Vegetation", "mol(C) m-2(grid box)", "boxC_green"},
{161, "C-Pool for Structural Material of Plants", "mol(C) m-2(grid box)", "boxC_woods"},
{162, "C-Pool for reserve carbohydrates (starches, sugars)", "mol(C) m-2(grid box)", "boxC_reserve"},
{163, "C-Pool for below ground non-woody litter (fine roots)", "mol(C) m-2(grid box)", "boxC_litter_green_bg"},
{164, "C-Pool for slowly respirated soil organic material", "mol(C) m-2(grid box)", "boxC_slow"},
{165, "Mean Leaf Area Index of the Previous Day", "-", "LAI_yDayMean"},
{166, "Mean NPP Rate of the Previous Day", "mol(CO2) m-2(canopy) s-1", "NPP_yDayMean"},
{167, "Mean GPP Rate of the Previous Day", "mol(CO2) m-2(canopy) s-1", "GPP_yDayMean"},
{168, "Previous Day Mean Temperature of the Uppermost Soil Layer", "K", "topSoilTemp_yDayMean"},
{169, "Previous Day Mean Value of the Water Stress Coefficient", "-", "alpha_yDayMean"},
{170, "Soil respiration", "mol(C) m-2(grid box) s-1", "box_soil_respiration"},
{171, "Mean potential NPP of the Previous Day", "mol(CO2) m-2(grid box) s-1", "box_NPP_yDayMean"},
{172, "Flux correction for NPP", "mol(CO2) m-2(grid box) s-1", "box_NPP_flux_correction"},
{173, "Mean GPP Rate of the Previous Day", "mol(CO2) m-2(grid box) s-1", "box_GPP_yDayMean"},
{175, "Total litter flux entering the soil pools", "mol(CO2) m-2(grid box) s-1", "box_litter_flux"},
{176, "Sum of carbon from all carbon pools", "mol(CO2) m-2(grid box)", "box_Cpools_total"},
{178, "Mean actual NPP the Previous Day", "mol(CO2) m-2(grid box) s-1", "box_NPP_act_yDayMean"},
{179, "C-Pool for above ground non-woody litter (leaves)", "mol(C) m-2(grid box)", "boxC_litter_green_ag"},
{181, "Growth Phase of Summergreens", "-", "growth_phase_SG"},
{182, "Growth Phase of Evergreens", "-", "growth_phase_EG"},
{185, "Air Temperature of the Previous Day", "degC", "previous_day_temp"},
{186, "Pseudo Soil Temperature", "degC", "pseudo_soil_temp"},
{188, "Heat Sum - Evergreens", "degC d", "heat_sum_EG"},
{189, "Heat Sum - Summergreens", "degC d", "heat_sum_SG"},
{190, "Number of Chill Days - Evergreens", "-", "chill_days_EG"},
{191, "Number of Chill Days - Summergreens", "-", "chill_days_SG"},
{196, "Growth Phase of extra-tropical crops", "-", "growth_phase_CRP"},
{197, "Heat Sum - Crops", "degC d", "heat_sum_CRP"},
{199, "Heat Sum - Winter Crops", "degC d", "heat_sum_winter"},
{203, "net surface NIR accumulated", "W/m**2", "jsswniracc"},
{204, "net surface visible accumulated", "W/m**2", "jsswvisacc"},
{205, "net surface diffuse NIR accumulated", "W/m**2", "jsswdifniracc"},
{205, "Minimum air Temp. of the Previous Day", "degC", "previous_day_temp_min"},
{206, "net surface diffuse visible accumulated", "W/m**2", "jsswdifvisacc"},
{206, "Maximum air Temp. of the Previous Day", "degC", "previous_day_temp_max"},
{207, "downward longwave radiation", "W/m**2", "longwave_down_acc"},
{210, "NPP_act_yDayMean", "mol(CO2) m-2(canopy) s-1", "NPP_act_yDayMean"},
{212, "roughness length of heat over land", "m", "az0lh"},
{213, "roughness length", "m", "az0"},
{244, "downward surface PAR accumulated", "W/m**2", "jsswparacc"},
{246, "downward surface diffuse PAR accumulated", "W/m**2", "jsswdifparacc"}
};
